' ======================== Keypad1.bas ========================

' Program uses an ADC approach to decoding a 4X4 matrix keypad.
' It sends the keypress ADC key value to the terminal window.
	
'	=== Constants ===
  symbol keypad = 4   ' keypad is connected to ADC4 input
		
' === Variables ===
  symbol junk = b0    ' throwaway variable used for debouncing
  symbol key  = w1    ' word variable is required for ADC10
 	
' === Directives ===
  #com 8              ' specify serial port
  #picaxe 08M         ' specify processor
  #terminal 9600      ' open terminal @ 9600 baud ( for 8MHz)
	
' ==================== Begin Main Program =====================

setfreq m8                            ' as fast as possible

do	
wait_for_keypress:
  readadc keypad, junk                ' get throwaway value
  if junk < 5 then wait_for_keypress  ' loop until key-press
	
  pause 100                           ' debounce keypress
  readadc10 keypad,key                ' and get ADC10 value
		
wait_for_release:	
  readadc keypad, junk                ' get throwaway value
  if junk > 5 then wait_for_release   ' loop until key-release
	
  sertxd ("key = ",#key,cr,lf)        ' send digits to terminal
loop