' ======================= keypad2.bas =========================

' Program uses an ADC approach to decoding a 4X4 matrix keypad.
' It sends the decoded character to the terminal window.
		
'	=== Constants ===
  symbol keypad = 4    ' keypad is connected to ADC4 input
		
' === Variables ===
  symbol char = b0    ' the char that corresponds to key value
  symbol junk = b1    ' throwaway variable used for debouncing	
  symbol key  = w1    ' word variable is required for ADC10

' === Directives ===
  #com 8              ' specify serial port
  #picaxe 08M         ' specify processor
  #terminal 9600      ' open terminal @ 9600 baud ( for 8MHz)
	
' ==================== Begin Main Program =====================

setfreq m8                            ' as fast as possible

do 
wait_for_keypress:
  readadc keypad, junk                ' get throwaway value
  if junk < 5 then wait_for_keypress  ' loop until key-press
	
  pause 100                           ' debounce keypress
  readadc10 keypad,key                ' and get ADC10 value
		
wait_for_release:	
  readadc keypad, junk                ' get throwaway value
  if junk > 5 then wait_for_release   ' loop until key-release
	
  select case key                     'decode key-press
' (Replace the theoretical values with actual values.)	
    case < 369 : char = 49      ' 1
    case < 385 : char = 50      ' 2
    case < 402 : char = 51      ' 3
    case < 434 : char = 65      ' A
    case < 450 : char = 52      ' 4
    case < 474 : char = 53      ' 5
    case < 500 : char = 54      ' 6
    case < 551 : char = 66      ' B
    case < 587 : char = 55      ' 7
    case < 634 : char = 56      ' 8
    case < 674 : char = 57      ' 9
    case < 733 : char = 67      ' C
    case < 804 : char = 42      ' *
    case < 885 : char = 48      ' 0
    case < 977 : char = 35      ' #
    else       : char = 68      ' D
  end select
	
  sertxd ("char = ",char,cr,lf) ' send decoded char to terminal
loop